import pytest
from lhcsmapi.metadata import signal_metadata
from nxcals.spark_session_builder import get_or_create

from lhcsmpowering import analyses

from . import common


@pytest.mark.parametrize(
    ("hwc_test", "circuit_name", "campaign", "t_start", "t_end", "expected_logs"),
    [
        (
            "PCC.5",
            "RCBXH1.R2",
            "Recommissioning 2022/2023",
            "2023-03-20 16:33:57.179",
            "2023-03-20 17:07:37.417",
            [
                "PM buffers and timestamps check",
                "\tCheck passed: Found exactly 3 PM timestamps for FGC RPMBB.UA27.RCBXH1.R2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS signal is 0.0012 A, which is within the threshold of 0.1000 A. Expected plateau level: -60.0000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF signal is 11.50 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS signal is 0.0010 A, which is within the threshold of 0.1000 A. Expected plateau level: 60.0000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF signal is 11.50 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS signal is 0.0011 A, which is within the threshold of 0.1000 A. Expected plateau level: -60.0000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF signal is 2.340 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS signal is 0.0010 A, which is within the threshold of 0.1000 A. Expected plateau level: 60.0000 A.",
                "PC voltage profile consistency check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF (ref test) signal is 11.50 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.00665 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.50 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF (ref test) signal is 11.50 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.00461 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.50 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF (ref test) signal is 11.50 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.00461 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.50 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF (ref test) signal is 2.300 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.00409 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.30 s.",
                "PC current decay check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS maximum deviation is 0.059 A compared to reference, which is within the threshold of ±5.000 A. Comparison period: 39.06 s.",
                "PC voltage decay check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.0154 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 4.86 s.",
                "Earth current check (positive cycle)",
                "\tCheck passed: The values of RPMBB.UA27.RCBXH1.R2 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA27.RCBXH1.R2 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA27.RCBXH1.R2 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA27.RCBXH1.R2 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF signal is 2.620 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS signal is 0.0009 A, which is within the threshold of 0.1000 A. Expected plateau level: -60.0000 A.",
                "PC voltage profile consistency check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA27.RCBXH1.R2 STATUS.I_REF (ref test) signal is 2.580 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.00409 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.58 s.",
                "PC current decay check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.I_MEAS maximum deviation is 0.017 A compared to reference, which is within the threshold of ±5.000 A. Comparison period: 28.58 s.",
                "PC voltage decay check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA27.RCBXH1.R2 STATUS.V_MEAS maximum deviation is 0.0051 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 5.52 s.",
                "Earth current check (negative cycle)",
                "\tCheck passed: The values of RPMBB.UA27.RCBXH1.R2 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
            ],
        ),
        (
            "PCC.5",
            "RCO.A12B2",
            "Recommissioning 2022/2023",
            "2023-03-17 07:34:23.491",
            "2023-03-17 08:24:15.636",
            [
                "PM buffers and timestamps check",
                "\tCheck passed: Found exactly 3 PM timestamps for FGC RPLB.UA23.RCO.A12B2, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF signal is 11.66 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA23.RCO.A12B2 STATUS.I_MEAS signal is 0.00291 A, which is within the threshold of 0.02000 A. Expected plateau level: -45.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA23.RCO.A12B2 STATUS.I_MEAS signal is 0.00268 A, which is within the threshold of 0.02000 A. Expected plateau level: 45.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA23.RCO.A12B2 STATUS.I_MEAS signal is 0.00297 A, which is within the threshold of 0.02000 A. Expected plateau level: -45.00000 A.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF signal is 2.720 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA23.RCO.A12B2 STATUS.I_MEAS signal is 0.00305 A, which is within the threshold of 0.02000 A. Expected plateau level: 45.00000 A.",
                "PC voltage profile consistency check (positive cycle)",
                "\tCheck passed: Target current is 45.00 A, which is equal to the reference target current of 45.00 A.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF (ref test) signal is 11.66 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.01535 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.66 s.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF (ref test) signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.01023 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.98 s.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF (ref test) signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.01535 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 11.98 s.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF (ref test) signal is 2.720 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.01535 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.72 s.",
                "PC current decay check (positive cycle)",
                "\tCheck skipped: RPLB FGCs do not have a current decay data.",
                "PC voltage decay check (positive cycle)",
                "\tCheck passed: Target current is 45.00 A, which is equal to the reference target current of 45.00 A.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.0051 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 0.48 s.",
                "Earth current check (positive cycle)",
                "\tCheck passed: The values of RPLB.UA23.RCO.A12B2 STATUS.I_EARTH_PCNT are within the margin of 0.0000 to 15.00 %.",
                "\tCheck passed: The values of RPLB.UA23.RCO.A12B2 STATUS.I_EARTH_PCNT are within the margin of 0.0000 to 15.00 %.",
                "\tCheck passed: The values of RPLB.UA23.RCO.A12B2 STATUS.I_EARTH_PCNT are within the margin of 0.0000 to 15.00 %.",
                "\tCheck passed: The values of RPLB.UA23.RCO.A12B2 STATUS.I_EARTH_PCNT are within the margin of 0.0000 to 15.00 %.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF signal is 2.560 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPLB.UA23.RCO.A12B2 STATUS.I_MEAS signal is 0.00291 A, which is within the threshold of 0.02000 A. Expected plateau level: -45.00000 A.",
                "PC voltage profile consistency check (negative cycle)",
                "\tCheck passed: Target current is 45.00 A, which is equal to the reference target current of 45.00 A.",
                "\tCheck passed: The plateau duration for RPLB.UA23.RCO.A12B2 STATUS.I_REF (ref test) signal is 2.580 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.01023 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.56 s.",
                "PC current decay check (negative cycle)",
                "\tCheck skipped: RPLB FGCs do not have a current decay data.",
                "PC voltage decay check (negative cycle)",
                "\tCheck passed: Target current is 45.00 A, which is equal to the reference target current of 45.00 A.",
                "\tCheck passed: The RPLB.UA23.RCO.A12B2 STATUS.V_MEAS maximum deviation is 0.0230 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 0.52 s.",
                "Earth current check (negative cycle)",
                "\tCheck passed: The values of RPLB.UA23.RCO.A12B2 STATUS.I_EARTH_PCNT are within the margin of 0.0000 to 15.00 %.",
            ],
        ),
        (
            "PCC.5",
            "RU.L4",
            "Recommissioning 2023/2024",
            "2024-02-15 13:50:08.462",
            "2024-02-15 14:52:43.740",
            [
                "Querying NXCALS returned no results for the variable RPMBB.UA43.RU.L4:I_EARTH_PCNT: system: CMW, start_time: 1614014429744000000, duration: 3785893000000, include_latest_data_point_prior_to_start: False, max_latest_data_point_search_period: 31,536,000,000,000,000",
                "PM buffers and timestamps check",
                "\tCheck passed: Found exactly 3 PM timestamps for FGC RPMBB.UA43.RU.L4, as expected.",
                "PC current profile consistency check (positive cycle)",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_REF signal is 10.000 s, which is greater than the minimum required duration of 8.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_MEAS signal is 0.00055 A, which is within the threshold of 0.08000 A. Expected plateau level: -60.00000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_REF signal is 10.000 s, which is greater than the minimum required duration of 8.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_MEAS signal is 0.00055 A, which is within the threshold of 0.08000 A. Expected plateau level: 60.00000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 STATUS.I_REF signal is 11.98 s, which is greater than the minimum required duration of 10.00 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA43.RU.L4 STATUS.I_MEAS signal is 0.00091 A, which is within the threshold of 0.08000 A. Expected plateau level: -60.00000 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 STATUS.I_REF signal is 2.720 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA43.RU.L4 STATUS.I_MEAS signal is 0.00107 A, which is within the threshold of 0.08000 A. Expected plateau level: 60.00000 A.",
                "PC voltage profile consistency check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_REF (ref test) signal is 10.000 s, which is greater than the minimum required duration of 8.000 s.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:V_MEAS maximum deviation is 0.00409 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 10.00 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_REF (ref test) signal is 10.000 s, which is greater than the minimum required duration of 8.000 s.",
                "\tInterpolating missing values in the signal and reference signal data.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:V_MEAS maximum deviation is 0.00256 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 10.00 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_REF (ref test) signal is 10.000 s, which is greater than the minimum required duration of 8.000 s.",
                "\tInterpolating missing values in the signal and reference signal data.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.V_MEAS maximum deviation is 0.02047 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 10.00 s.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 STATUS.I_REF (ref test) signal is 2.740 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.V_MEAS maximum deviation is 0.00358 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.72 s.",
                "PC current decay check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.I_MEAS maximum deviation is 0.315 A compared to reference, which is within the threshold of ±4.000 A. Comparison period: 7.22 s.",
                "PC voltage decay check (positive cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.V_MEAS maximum deviation is 0.0041 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 0.10 s.",
                "Earth current check (positive cycle)",
                "\tCheck passed: The values of RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA43.RU.L4 RPMBB.UA43.RU.L4:I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA43.RU.L4 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "\tCheck passed: The values of RPMBB.UA43.RU.L4 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
                "PC current profile consistency check (negative cycle)",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 STATUS.I_REF signal is 2.560 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The maximum plateau level deviation for RPMBB.UA43.RU.L4 STATUS.I_MEAS signal is 0.00098 A, which is within the threshold of 0.08000 A. Expected plateau level: -60.00000 A.",
                "PC voltage profile consistency check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The plateau duration for RPMBB.UA43.RU.L4 STATUS.I_REF (ref test) signal is 2.600 s, which is greater than the minimum required duration of 2.000 s.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.V_MEAS maximum deviation is 0.00307 V compared to reference, which is within the threshold of ±0.05000 V. Comparison period: 2.56 s.",
                "PC current decay check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.I_MEAS maximum deviation is 0.299 A compared to reference, which is within the threshold of ±4.000 A. Comparison period: 7.16 s.",
                "PC voltage decay check (negative cycle)",
                "\tCheck passed: Target current is 60.00 A, which is equal to the reference target current of 60.00 A.",
                "\tCheck passed: The RPMBB.UA43.RU.L4 STATUS.V_MEAS maximum deviation is 0.0102 V compared to reference, which is within the threshold of ±0.5000 V. Comparison period: 2.16 s.",
                "Earth current check (negative cycle)",
                "\tCheck passed: The values of RPMBB.UA43.RU.L4 STATUS.I_EARTH_PCNT are within the margin of -10.00 to 10.00 %.",
            ],
        ),
    ],
)
def test_pcc_5(hwc_test: str, circuit_name: str, campaign: str, t_start: str, t_end: str, expected_logs: list[str]):
    # arrange
    test_parameters = analyses.get_analysis_test_input_parameters(
        signal_metadata.get_hwc_summary(), hwc_test, circuit_name, campaign, t_start, t_end
    )

    # act
    analysis_class = analyses.Pcc5Analysis("", test_parameters)
    analysis_class.set_spark(get_or_create())
    analysis_class.query()
    analysis_class.analyze()

    # assert
    assert analysis_class.get_analysis_output() is True
    assert common.get_log_strings(analysis_class) == expected_logs
